/*
 *  nvj - NattoView/Java 
 *  (c) 2005-2007 Hidekazu Shiozawa
 *  http://vilab.org
 */

public abstract class NvLayout {

    protected int dimension = 16;

    public abstract int layout(NvChart chart);
    
    public void locateNewNode(NvNode node, NvNode parent) {
        double theta = 2 * Math.PI * Math.random();
        double r = dimension / 20.0f;
        node.x = node.xTarget = parent.x + (float)(r * Math.cos(theta));
        node.y = node.yTarget = parent.y + (float)(r * Math.sin(theta));
    }
    
    public boolean animation(NvChart chart) {
        boolean changed = false;
        for (NvNode node: chart.getNodes()) {
            float dx = node.xTarget - node.x;
            if (dx != 0) {
                if (Math.abs(dx) < dimension / 100.0f)
                    node.x = node.xTarget;
                else
                    node.x += dx * dimension / 100.0f;
                changed = true;
            }
            float dy = node.yTarget - node.y;
            if (dy != 0) {
                if (Math.abs(dy) < dimension / 100.0f)
                    node.y = node.yTarget;
                else
                    node.y += dy * dimension / 100.0f;
                changed = true;
            }
        }
        return changed;
    }
}
