/*
 *  nvj - NattoView/Java 
 *  (c) 2005-2007 Hidekazu Shiozawa
 *  http://vilab.org
 */

import java.net.MalformedURLException;
import java.net.URL;

public class WebNode extends NvNode {

    protected String encoding;

    static public URL urlToId(URL url) {
        try {
            String path = url.getFile();
            if (path.equals(""))
                path = "/"; // ******************
            url = new URL(url, path);
        } catch (MalformedURLException e) {
            ;
        }
        return url;
    }

    public WebNode(NvChart chart, URL id, String label) {
        super(chart, id, label);
    }

    public String getLabel(int maxlen) {
        String l = label;
        URL url = (URL)id;
        if (l == null || l.length() == 0)
            l = url.getFile();
        if (l == null || l.length() == 0 || l.equals(""))
            l = url.getHost();
        if (l == null || l.length() == 0)
            l = url.toString();
        if (maxlen != 0 && l.length() > maxlen)
            l = l.substring(0, maxlen);
        return l;
    }
}
